<?php
use Doctrine\DBAL\Types\Type;

require "autoloader.php";
require __DIR__."/../vendor/autoload.php";
require __DIR__."/../vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/../vendor/teknisa/pebLibraries/bootstrap.php";

$routes = array();
$routes[] = __DIR__.'/../config/routes.json';

// Load specified services and parameters
$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();
$instanceManager->loadFromFile(__DIR__."/../config/environment.xml");
$instanceManager->loadFromFile(__DIR__."/../config/services.xml");
$instanceManager->loadFromFile(__DIR__."/../config/config.xml");

$modulesFolders = array_diff(scandir(__DIR__."/../src/Modules/"), [".", ".."]);

foreach($modulesFolders as $module){ //Le todos diretorios dentro da pasta Modules de forma dinamica
    $files = array_diff(scandir(__DIR__."/../src/Modules/".$module."/config"), [".", ".."]);
    foreach($files as $file){ //Le todos arquivos dentro da pasta config e separa entre json e xml
        $extension = explode(".",$file)[1];
        if($extension == 'json')
            $routes[] = __DIR__."/../src/Modules/".$module."/config/".$file;   //leitura dinamica dos arquivos .json
        else
            $instanceManager->loadFromFile(__DIR__."/../src/Modules/".$module."/config/".$file); //leitura dinamica dos arquivos .xml
    }
}

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

//Alter connection to DB
$container = $instanceManager->getContainer();
$connParams = $container->getParameter('connection_params');
$headers = getallheaders();
$connParams['user'] = $headers['dbuser']?? $connParams['user'];
$connParams['password'] = $headers['dbpass']?? $connParams['password'];
$connParams['host'] = $headers['dbhost']?? $connParams['host'];
$connParams['port'] = $headers['dbport']?? $connParams['port'];
$connParams['dbname'] = $headers['dbname']?? $connParams['dbname'];
$connParams['useVpd'] = $headers['useVpd']?? $connParams['useVpd'];
$connParams['vpdWithWallet'] = $headers['vpdWithWallet']?? $connParams['vpdWithWallet'];

$container->setParameter('connection_params', $connParams);

$instanceManager->compile(); 

//Necessário para uso das entidades do projetotecfood
Type::overrideType(Type::DATE, 'Setforms2\Shared\ORM\DateType');
Type::overrideType(Type::DATETIME, 'Setforms2\Shared\ORM\DateTimeType');
$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());