<?php

namespace Modules\CADEST\Controllers;

class Produto {
    protected $connection;
    protected $newCodeNT;
    protected $Utils;
    public function __construct($connection, $UtilsIntegracao){
        $this->connection = $connection;
        $this->Utils = $UtilsIntegracao;
    }
    
    /**
     * www.apiteknisa.com/cadEst/produto?DTINCLUSAO=27/01/2017&IDESTOCOMP=A
    */

    public function endpointGetProduto($request, $response){
        try{
            $idestocomp = strtoupper($this->Utils->parametro($request, 'IDESTOCOMP'));
            $dtinclusao = $this->Utils->parametro($request, 'DTINCLUSAO');
            
            if ($idestocomp != 'C' && $idestocomp != 'E' && $idestocomp != 'A') $this->Utils->incluiMensagem('Tipo de produto informado não é um valor válido. Espera-se: C (Compras), E (Estoque) ou A (Ambos)', true);
            
            if(empty($dtinclusao)) $this->Utils->incluiMensagem('Data não informada', true);
            
            if(!$this->Utils->dataValida($dtinclusao)) $this->Utils->incluiMensagem('Data informada não é um valor válido', true);
            
            if($this->Utils->statusAtual() == 'E'){
                $this->Utils->retornoJSONStatusMensagem($response);
                return;    
            }
            
            if ($idestocomp === 'A') $idestocomp = 'E_C_';
            
            $query = "SELECT CDARVPROD, NMPRODUTO, SGUNIDADE, VRPESOUNID, VRPESOLIQUPR,
                                VRPESOBRUTPR, VRPEFATOCORR, VRFATOCONV, VRARREDREQ, VRARREDCMP, 
                                CDBARPRODUTO, IDPRODATIVPR, CDARVPRODEST,
                                NMPRODESTO, CDCLASFISC, CDGENPROD, CDCEST, 
                                TO_CHAR(DTINCLUSAO, 'DD/MM/YYYY') DTINCLUSAO, IDESTOCOMP FROM (
                        SELECT P.CDARVPROD, P.NMPRODUTO, P.SGUNIDADE, P.VRPESOUNID, P.VRPESOLIQUPR,
                                P.VRPESOBRUTPR, P.VRPEFATOCORR, P.VRFATOCONV, P.VRARREDREQ, P.VRARREDCMP, 
                                P.CDBARPRODUTO, P.IDPRODATIVPR, PRODESTO.CDARVPROD AS CDARVPRODEST,
                                PRODESTO.NMPRODESTO, P.CDCLASFISC, P.CDGENPROD, P.CDCEST, 
                                P.DTINCLUSAO,
                                CASE
                                   WHEN P.CDPRODUTO = P.CDPRODESTO THEN
                                       'E'
                                   ELSE
                                       'C'
                                END AS IDESTOCOMP
                              FROM PRODUTO P
                              LEFT JOIN (
                                SELECT NMPRODUTO AS NMPRODESTO,
                                       CDPRODUTO, CDARVPROD
                                  FROM PRODUTO
                            )       PRODESTO ON P.CDPRODESTO = PRODESTO.CDPRODUTO
                             WHERE CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                                ) A
                                WHERE INSTR(:IDESTOCOMP, A.IDESTOCOMP) > 0
                                AND A.DTINCLUSAO >= :DTINCLUSAO
    
                             ORDER BY A.CDARVPROD";
            
            $params = [
                "DTINCLUSAO" => $dtinclusao,
                "IDESTOCOMP" => $idestocomp
            ];
            
            $prepared = $this->connection->prepare($query);
            $prepared->execute($params);
            $data = $prepared->fetchAll();
            $this->Utils->retornoJSON($response, $data);
        }catch(\Exception $e){
            if($this->Utils->modoDesenvolvedor())
                throw $e;
            $this->Utils->incluiMensagem("Ocorreu um erro não esperado na execução da rotina. Verifique os parâmetros e tente novamente", true);
            $this->Utils->retornoJSONStatusMensagem($response);
        }
    }
}